package sdanderson.androidcharts.LineChart;

import android.graphics.Paint;

import java.util.List;

import sdanderson.androidcharts.Common.Coordinate;

/**
 * Created by Shane Anderson on 9/30/2015.
 *
 */
class LineChartItem {

    private String mLabel;
    private List<Coordinate<Float, Float>> mCoordinates;

    private Paint mLinePaint;
    private float mLineThickness = 4f;

    public LineChartItem (String pLabel, List<Coordinate<Float, Float>> pCoordinates,
                          int pLineColor) {
        mLabel = pLabel;
        mCoordinates = pCoordinates;

        mLinePaint = new Paint();
        mLinePaint.setStyle(Paint.Style.FILL);
        mLinePaint.setColor(pLineColor);
        mLinePaint.setAntiAlias(true);
    }

    @SuppressWarnings("unused")
    protected void setLineThickness(float pLineThickness) { mLineThickness = pLineThickness; }

    protected float getLineThickness() { return mLineThickness; }

    @SuppressWarnings("unused")
    protected void setLineColor(int pLineColor) { mLinePaint.setColor(pLineColor); }

    protected int getLineColor() { return mLinePaint.getColor(); }

    protected void setLabel(String pLabel) { mLabel = pLabel; }

    protected String getLabel() { return mLabel; }

    @SuppressWarnings("unused")
    protected void setCoordinates(List<Coordinate<Float, Float>> pValues) {
        mCoordinates = pValues;
    }

    protected List<Coordinate<Float, Float>> getCoordinates() { return mCoordinates; }

    protected Coordinate<Float, Float> getCoordinatesAtIndex(int pIndex) {
        return mCoordinates.get(pIndex);
    }

    @SuppressWarnings("unused")
    protected Float getMinXValue() {
        Float min = null;
        if (mCoordinates.size() > 0) {
            min = mCoordinates.get(0).getX();

            for (Coordinate<Float, Float> tempCoordinate:mCoordinates) {
                if (tempCoordinate.getX() < min)
                    min = tempCoordinate.getX();
            }
        }

        return min;
    }

    @SuppressWarnings("unused")
    protected Float getMaxXValue() {
        Float max = null;
        if (mCoordinates.size() > 0) {
            max = mCoordinates.get(0).getX();

            for (Coordinate<Float, Float> tempCoordinate:mCoordinates) {
                if (tempCoordinate.getX() > max)
                    max = tempCoordinate.getX();
            }
        }

        return max;
    }

    @SuppressWarnings("unused")
    protected Float getMinYValue() {
        Float min = null;
        if (mCoordinates.size() > 0) {
            min = mCoordinates.get(0).getY();

            for (Coordinate<Float, Float> tempCoordinate:mCoordinates) {
                if (tempCoordinate.getY() < min)
                    min = tempCoordinate.getY();
            }
        }

        return min;
    }

    @SuppressWarnings("unused")
    protected Float getMaxYValue() {
        Float max = null;
        if (mCoordinates.size() > 0) {
            max = mCoordinates.get(0).getY();

            for (Coordinate<Float, Float> tempCoordinate:mCoordinates) {
                if (tempCoordinate.getY() > max)
                    max = tempCoordinate.getY();
            }
        }

        return max;
    }

}
